Index: django/conf/global_settings.py
===================================================================
--- django/conf/global_settings.py	(revision 6023)
+++ django/conf/global_settings.py	(working copy)
@@ -328,6 +328,9 @@
 
 LOGIN_REDIRECT_URL = '/accounts/profile/'
 
+# The class to use as the default AUTH_USER for the authentication system.
+AUTH_USER_MODULE = 'django.contrib.auth.default_user.User'
+
 ###########
 # TESTING #
 ###########
Index: django/contrib/auth/default_user.py
===================================================================
--- django/contrib/auth/default_user.py	(revision 0)
+++ django/contrib/auth/default_user.py	(revision 0)
@@ -0,0 +1,27 @@
+from django.db import models
+from django.core import validators
+from django.utils.translation import gettext_lazy as _
+
+from django.contrib.auth.models import Group, Permission, UserManager, UserTemplate
+
+import datetime
+
+class User(models.Model, UserTemplate):
+    """Users within the Django authentication system are represented by this model.
+
+    Username and password are required. Other fields are optional.
+    """
+    username = models.CharField(_('username'), max_length=30, unique=True, validator_list=[validators.isAlphaNumeric], help_text=_("Required. 30 characters or fewer. Alphanumeric characters only (letters, digits and underscores)."))
+    first_name = models.CharField(_('first name'), max_length=30, blank=True)
+    last_name = models.CharField(_('last name'), max_length=30, blank=True)
+    email = models.EmailField(_('e-mail address'), blank=True)
+    password = models.CharField(_('password'), max_length=128, help_text=_("Use '[algo]$[salt]$[hexdigest]' or use the <a href=\"password/\">change password form</a>."))
+    is_staff = models.BooleanField(_('staff status'), default=False, help_text=_("Designates whether the user can log into this admin site."))
+    is_active = models.BooleanField(_('active'), default=True, help_text=_("Designates whether this user can log into the Django admin. Unselect this instead of deleting accounts."))
+    is_superuser = models.BooleanField(_('superuser status'), default=False, help_text=_("Designates that this user has all permissions without explicitly assigning them."))
+    last_login = models.DateTimeField(_('last login'), default=datetime.datetime.now)
+    date_joined = models.DateTimeField(_('date joined'), default=datetime.datetime.now)
+    groups = models.ManyToManyField(Group, verbose_name=_('groups'), blank=True,
+        help_text=_("In addition to the permissions manually assigned, this user will also get all permissions granted to each group he/she is in."))
+    user_permissions = models.ManyToManyField(Permission, verbose_name=_('user permissions'), blank=True)
+    objects = UserManager()
Index: django/contrib/auth/models.py
===================================================================
--- django/contrib/auth/models.py	(revision 6023)
+++ django/contrib/auth/models.py	(working copy)
@@ -4,6 +4,7 @@
 from django.contrib.contenttypes.models import ContentType
 from django.utils.encoding import smart_str
 from django.utils.translation import ugettext_lazy as _
+from django.conf import settings
 import datetime
 import urllib
 
@@ -100,26 +101,7 @@
         from random import choice
         return ''.join([choice(allowed_chars) for i in range(length)])
 
-class User(models.Model):
-    """Users within the Django authentication system are represented by this model.
-
-    Username and password are required. Other fields are optional.
-    """
-    username = models.CharField(_('username'), max_length=30, unique=True, validator_list=[validators.isAlphaNumeric], help_text=_("Required. 30 characters or fewer. Alphanumeric characters only (letters, digits and underscores)."))
-    first_name = models.CharField(_('first name'), max_length=30, blank=True)
-    last_name = models.CharField(_('last name'), max_length=30, blank=True)
-    email = models.EmailField(_('e-mail address'), blank=True)
-    password = models.CharField(_('password'), max_length=128, help_text=_("Use '[algo]$[salt]$[hexdigest]' or use the <a href=\"password/\">change password form</a>."))
-    is_staff = models.BooleanField(_('staff status'), default=False, help_text=_("Designates whether the user can log into this admin site."))
-    is_active = models.BooleanField(_('active'), default=True, help_text=_("Designates whether this user can log into the Django admin. Unselect this instead of deleting accounts."))
-    is_superuser = models.BooleanField(_('superuser status'), default=False, help_text=_("Designates that this user has all permissions without explicitly assigning them."))
-    last_login = models.DateTimeField(_('last login'), default=datetime.datetime.now)
-    date_joined = models.DateTimeField(_('date joined'), default=datetime.datetime.now)
-    groups = models.ManyToManyField(Group, verbose_name=_('groups'), blank=True,
-        help_text=_("In addition to the permissions manually assigned, this user will also get all permissions granted to each group he/she is in."))
-    user_permissions = models.ManyToManyField(Permission, verbose_name=_('user permissions'), blank=True)
-    objects = UserManager()
-
+class UserTemplate(object):
     class Meta:
         verbose_name = _('user')
         verbose_name_plural = _('users')
@@ -265,6 +247,22 @@
                 raise SiteProfileNotAvailable
         return self._profile_cache
 
+
+# Grab the AUTH_USER_MODULE path and classname from the settings.
+# auth_user_module_parts[0] = module path
+# auth_user_module_parts[1] = class name
+auth_user_module_parts = settings.AUTH_USER_MODULE.rsplit('.', 1)
+auth_user_module = __import__(auth_user_module_parts[0], {}, {}, [auth_user_module_parts[0]])
+# Store the auth_user model so it is accessible with the standard 'from django.contrib.auth.models import User'
+User = getattr(auth_user_module, auth_user_module_parts[1])
+
+# Add the User model to the django models cache
+# These two lines allow the custom auth_user model to play nicely with syncdb and other systems that rely
+# on functions like django.db.models.loading.get_model(...)
+from django.db.models.loading import cache
+cache.register_models('auth', User)
+
+
 class Message(models.Model):
     """
     The message system is a lightweight way to queue messages for given users. A message is associated with a User instance (so it is only applicable for registered users). There's no concept of expiration or timestamps. Messages are created by the Django admin after successful actions. For example, "The poll Foo was created successfully." is a message.