Index: docs/internals/deprecation.txt
===================================================================
--- docs/internals/deprecation.txt	(revision 15652)
+++ docs/internals/deprecation.txt	(working copy)
@@ -41,9 +41,10 @@
           removed.
 
         * The ``get_db_prep_save``, ``get_db_prep_value`` and
-          ``get_db_prep_lookup`` methods on Field were modified in 1.2 to support
-          multiple databases. In 1.4, the support functions that allow methods
-          with the old prototype to continue working will be removed.
+          ``get_db_prep_lookup`` methods on Field were modified in 1.2
+          to support multiple databases. In 1.4, the support functions
+          that allow methods with the old prototype to continue
+          working will be removed.
 
         * The ``Message`` model (in ``django.contrib.auth``), its related
           manager in the ``User`` model (``user.message_set``), and the
@@ -105,6 +106,10 @@
           with a trailing slash to ensure there is a consistent way to
           combine paths in templates.
 
+	* ``XMLField`` was deprecated in 1.3 and will be removed in
+          1.4. This accelerated process was chosen since the field
+          hasn't worked properly since oldforms was removed.
+
     * 1.5
         * The ``mod_python`` request handler has been deprecated since the 1.3
           release. The ``mod_wsgi`` handler should be used instead.
Index: docs/topics/forms/modelforms.txt
===================================================================
--- docs/topics/forms/modelforms.txt	(revision 15652)
+++ docs/topics/forms/modelforms.txt	(working copy)
@@ -106,9 +106,6 @@
 
     ``URLField``                     ``URLField`` with ``verify_exists`` set
                                      to the model field's ``verify_exists``
-
-    ``XMLField``                     ``CharField`` with
-                                     ``widget=forms.Textarea``
     ===============================  ========================================
 
 .. versionadded:: 1.2
Index: docs/ref/models/fields.txt
===================================================================
--- docs/ref/models/fields.txt	(revision 15652)
+++ docs/ref/models/fields.txt	(working copy)
@@ -836,17 +836,18 @@
 ``XMLField``
 ------------
 
+.. versionchanged:: 1.3
+   ``XMLField`` is deprecated. Use TextField instead.
+
 .. class:: XMLField(schema_path=None, [**options])
 
-A :class:`TextField` that checks that the value is valid XML that matches a
-given schema. Takes one required argument:
+A :class:`TextField` that stores XML data and a path to a schema. Takes one 
+optional argument:
 
 .. attribute:: schema_path
 
-    The filesystem path to a RelaxNG_ schema against which to validate the
-    field.
+    The filesystem path to a schema for the field.
 
-.. _RelaxNG: http://www.relaxng.org/
 
 Relationship fields
 ===================
Index: tests/regressiontests/serializers_regress/tests.py
===================================================================
--- tests/regressiontests/serializers_regress/tests.py	(revision 15652)
+++ tests/regressiontests/serializers_regress/tests.py	(working copy)
@@ -222,9 +222,6 @@
     (data_obj, 180, USStateData, "MA"),
     (data_obj, 181, USStateData, None),
     (data_obj, 182, USStateData, ""),
-    (data_obj, 190, XMLData, "<foo></foo>"),
-    (data_obj, 191, XMLData, None),
-    (data_obj, 192, XMLData, ""),
 
     (generic_obj, 200, GenericData, ['Generic Object 1', 'tag1', 'tag2']),
     (generic_obj, 201, GenericData, ['Generic Object 2', 'tag2', 'tag3']),
Index: tests/regressiontests/serializers_regress/models.py
===================================================================
--- tests/regressiontests/serializers_regress/models.py	(revision 15652)
+++ tests/regressiontests/serializers_regress/models.py	(working copy)
@@ -79,9 +79,6 @@
 class USStateData(models.Model):
     data = USStateField(null=True)
 
-class XMLData(models.Model):
-    data = models.XMLField(null=True)
-
 class Tag(models.Model):
     """A tag on an item."""
     data = models.SlugField()
@@ -218,9 +215,6 @@
 class USStatePKData(models.Model):
     data = USStateField(primary_key=True)
 
-# class XMLPKData(models.Model):
-#     data = models.XMLField(primary_key=True)
-
 class ComplexModel(models.Model):
     field1 = models.CharField(max_length=10)
     field2 = models.CharField(max_length=10)
Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 15652)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -1136,6 +1136,10 @@
     description = _("XML text")
 
     def __init__(self, verbose_name=None, name=None, schema_path=None, **kwargs):
+        import warnings
+        warnings.warn("XMLField is deprecated, please migrate to "
+                      "TextField for equivalent functionality", 
+                      DeprecationWarning)
         self.schema_path = schema_path
         Field.__init__(self, verbose_name, name, **kwargs)
 
Index: django/contrib/gis/utils/layermapping.py
===================================================================
--- django/contrib/gis/utils/layermapping.py	(revision 15652)
+++ django/contrib/gis/utils/layermapping.py	(working copy)
@@ -54,6 +54,8 @@
         models.TextField : OFTString,
         models.URLField : OFTString,
         USStateField : OFTString,
+        #This is a reminder that XMLField is deprecated 
+        # and this needs to be removed in 1.4
         models.XMLField : OFTString,
         models.SmallIntegerField : (OFTInteger, OFTReal, OFTString),
         models.PositiveSmallIntegerField : (OFTInteger, OFTReal, OFTString),